# Generated automatically from Makefile.in by configure.
# $Id: Makefile.c++,v 1.1.1.1 1998/06/07 12:01:15 kuriyama Exp $
################################################################################
# Copyright 1996 by Thomas E. Dickey <dickey@clark.net>                        #
# All Rights Reserved.                                                         #
#                                                                              #
# Permission to use, copy, modify, and distribute this software and its        #
# documentation for any purpose and without fee is hereby granted, provided    #
# that the above copyright notice appear in all copies and that both that      #
# copyright notice and this permission notice appear in supporting             #
# documentation, and that the name of the above listed copyright holder(s) not #
# be used in advertising or publicity pertaining to distribution of the        #
# software without specific, written prior permission. THE ABOVE LISTED        #
# COPYRIGHT HOLDER(S) DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,    #
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT #
# SHALL THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY SPECIAL,        #
# INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM   #
# LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE   #
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR    #
# PERFORMANCE OF THIS SOFTWARE.                                                #
################################################################################
#  Simple makefile for c++ window class demo

# turn off _all_ suffix rules; we'll generate our own
.SUFFIXES:

SHELL		= /bin/sh

MODEL		= ../c++
srcdir		= .
prefix		= /usr/local
exec_prefix	= ${prefix}
libdir		= ${exec_prefix}/lib
includedir	= /usr/local/include/ncurses

ABI_VERSION	= 3.4

CXX		= c++
CXXFLAGS	= -O

CPPFLAGS	=  -DNDEBUG -I. -I../include -I${includedir} -DHAVE_CONFIG_H

CCFLAGS		= $(CPPFLAGS) $(CXXFLAGS)

CFLAGS_NORMAL	= $(CCFLAGS)
CFLAGS_DEBUG	= $(CCFLAGS) -g -DTRACE
CFLAGS_PROFILE	= $(CCFLAGS) -pg
CFLAGS_SHARED	= $(CCFLAGS) -fpic -DPIC

CFLAGS_DEFAULT	= $(CFLAGS_SHARED)

LINK		= $(CXX)
LDFLAGS		=    

all: demo

OBJS_DEMO = \
	$(MODEL)/cursesw.o \
	$(MODEL)/cursesp.o \
	$(MODEL)/demo.o
DEPS_DEMO = \
	$(OBJS_DEMO) \
	${prefix}/lib/libpanel.so.$(ABI_VERSION) \
	${prefix}/lib/libncurses.so.$(ABI_VERSION)
demo: $(DEPS_DEMO)
	 $(LINK) -o $@ $(DEPS_DEMO) $(LDFLAGS) -lg++ -lm

install:
install.libs:

clean ::
	-rm -f demo $(OBJS_DEMO)

distclean :: clean
	-rm -f Makefile

mostlyclean :: clean

realclean :: distclean

###############################################################################
# The remainder of this file is automatically generated during configuration
###############################################################################

# generated by mk-0th.awk


lintlib :
	@echo no action needed

# generated by mk-1st.awk



# generated by mk-2nd.awk


../c++/cursesp.o :	$(srcdir)/cursesp.cc \
			$(srcdir)/cursesp.h
			$(CXX) $(CFLAGS_SHARED) -c ../c++/cursesp.cc

../c++/cursesw.o :	$(srcdir)/cursesw.cc \
			$(srcdir)/cursesw.h
			$(CXX) $(CFLAGS_SHARED) -c ../c++/cursesw.cc

../c++/demo.o :	$(srcdir)/demo.cc \
			$(srcdir)/cursesp.h \
			$(srcdir)/cursesw.h
			$(CXX) $(CFLAGS_SHARED) -c ../c++/demo.cc


# generated by mk-1st.awk



# generated by mk-2nd.awk


../objects/cursesp.o :	$(srcdir)/cursesp.cc \
			$(srcdir)/cursesp.h
	cd ../objects; $(CXX) $(CFLAGS_NORMAL) -c ../c++/cursesp.cc

../objects/cursesw.o :	$(srcdir)/cursesw.cc \
			$(srcdir)/cursesw.h
	cd ../objects; $(CXX) $(CFLAGS_NORMAL) -c ../c++/cursesw.cc

../objects/demo.o :	$(srcdir)/demo.cc \
			$(srcdir)/cursesp.h \
			$(srcdir)/cursesw.h
	cd ../objects; $(CXX) $(CFLAGS_NORMAL) -c ../c++/demo.cc


# generated by mk-1st.awk



# generated by mk-2nd.awk


../obj_g/cursesp.o :	$(srcdir)/cursesp.cc \
			$(srcdir)/cursesp.h
	cd ../obj_g; $(CXX) $(CFLAGS_DEBUG) -c ../c++/cursesp.cc

../obj_g/cursesw.o :	$(srcdir)/cursesw.cc \
			$(srcdir)/cursesw.h
	cd ../obj_g; $(CXX) $(CFLAGS_DEBUG) -c ../c++/cursesw.cc

../obj_g/demo.o :	$(srcdir)/demo.cc \
			$(srcdir)/cursesp.h \
			$(srcdir)/cursesw.h
	cd ../obj_g; $(CXX) $(CFLAGS_DEBUG) -c ../c++/demo.cc

